
#include <time.h>


#define MAX 1000000

int linear( int X[], int n, int k);
int binary( int X[],int n, int k);

int linear( int X[], int n, int k)
{
 int i=0;

 while ( i < n )
  {
   if (X[i] == k)
	return i;
   if (X[i] > k)
	return -1;
   i++;
  }
 return -1;
}

int binary( int X[],int n,int k)
{
 int low = 0, high = n-1;
 int mid;

 while ( low < high )
  {
   mid = (high + low)/2;
   if (X[mid] < k)
	low = mid + 1;
   else
   	if (X[mid] > k)
		high=mid-1;
   	else
		return mid;
  }
 return -1;
}

int main( void ){

   int sorted_table[MAX];
   int element, i;

   for (i=0; i<MAX; i++)
	sorted_table[i] = i;

   printf("Enter the element you are searching for: " );
   scanf("%d", &element);

   clock_t start, finish;
   //duration is the program execution
   double  duration;
   int delay = 2;

   //Measure the duration of the linear search
   start = clock();
   linear(sorted_table, MAX, element);
   finish = clock();

   duration = (double)(finish - start) / CLOCKS_PER_SEC;

   // Printing the results
   printf("\nPrinting the linear method results\n");
   printf("Start:%u\n", start);
   printf("Finish:%u\n", finish);
   printf( "Duration:%5.1f seconds\n", duration);
   printf( "Duration:%5.0f miliseconds\n", duration*1000);


   //Measure the duration of the binary search
   start = clock();
   binary(sorted_table, MAX, element);
   finish = clock();

   duration = (double)(finish - start) / CLOCKS_PER_SEC;

   // Printing the results
   printf("Printing the binary method results\n");
   printf("Start:%u\n", start);
   printf("Finish:%u\n", finish);
   printf( "Duration:%5.1f seconds\n", duration);
   printf( "Duration:%5.0f miliseconds\n", duration*1000);

}

